
#ifndef __PC__
#include <p33FJ64GP306.h>
#include "integer.h"
_FPOR(FPWRT_PWR128);			//Power on Reset value = 128ms,

_FOSCSEL(FNOSC_PRIPLL);			// Primary (XT, HS, EC) Oscillator with PLL

_FOSC(FCKSM_CSDCMD & OSCIOFNC_OFF  & POSCMD_EC);  
								// Clock Switching and Fail Safe Clock Monitor is disabled
								// OSC2 Pin Function: OSC2 is Clock Output
								// Primary Oscillator Mode: EC, External
								
_FWDT(FWDTEN_OFF);              // Watchdog Timer Enabled/disabled by user software
								// (LPRC can be disabled by clearing SWDTEN bit in RCON register
#endif

void Init_cpu(void)
{

// Configure Oscillator to operate the device at 67.73MHz.
// Fref = Fin / N1 = 5.644MHz < 8MHz
// Fvco = Fref*M = 135.456MHz < 200MHz
// Fosc= Fvco / N2 = 67.728MHz < 80MHz
// Fcy = Fosc/2 = 33.864MHz < 40MHz (Instruction Clock)
#ifndef __PC__
	CLKDIVbits.PLLPOST=0;		// N1=2
	PLLFBD=22;					// M=24
	CLKDIVbits.PLLPRE=0;		// N2=2
	
// Disable Watch Dog Timer
    RCONbits.SWDTEN=0;

// Wait for PLL to lock
	while(OSCCONbits.LOCK!=1) {};

    unsigned short i; 
    
    for(i=0;i<0xffff;i++)ClrWdt(); 
    for(i=0;i<0xffff;i++)ClrWdt(); 
    //Wait very long 
#endif
	
}
