#include "integer.h"

//FCY: 
#define	FCY		33868800
#define	FS		44100
#define	FCSCK	64*FS

//BCG: Bit Clock Generator
#define BCG_VAL  (FCY/(2*FCSCK))-1

#define SAMPLE_RATE  (44100)
#define NUM_CHANNELS    (2)
#define SAMPLE_SIZE (2)

#ifdef __PC__
//For PC, use portaudio
#include "portaudio.h"
#define PA_SAMPLE_TYPE  paInt16
#endif

//common, intermediate buffer
#ifdef __PC__
#define FRAMES_PER_BUFFER (1024)
#else
#define FRAMES_PER_BUFFER (128)
#endif
//intermediate buffer, per block, must be FRAMES_PER_BUFFER*NUM_CHANNELS*SAMPLE_SIZE
#define	BLOCKSIZE FRAMES_PER_BUFFER*NUM_CHANNELS*SAMPLE_SIZE
#define BLOCKNUM 8		//intermediate buffer size = BLOCKSIZE * BLOCKNUM

typedef struct
{
	short numBytes;	//Block Size, for Device (DCI for PIC, PortAudio for PC)

	BYTE DeviceOutCursor;		//0 to 7, Cursor to read intermediate buffer
	BYTE FilledFlag[BLOCKNUM];			//filled(produced) = 1, blank(consumed) = 0
	unsigned char pOutput[BLOCKNUM][BLOCKSIZE];	//intermediate buffer ring(just pingpong)

} PLAYBACKDATA;

// Functions
void SetPlayBackStruct(PLAYBACKDATA *);
void Init_playdevice(PLAYBACKDATA *);
void playdevice_start(void);
void playdevice_stop(void);
void playdevice_dma0_Init(void);
void playdevice_dma0_start(PLAYBACKDATA *);
void playdevice_dma0_stop(void);
void initplaydeviceBuff(PLAYBACKDATA *);
void InitPlayBackStruct(PLAYBACKDATA *);

#ifndef __PC__
extern void __attribute__((__interrupt__)) _DCIInterrupt(void);
#else

PaStreamParameters outputParameters;
PaStream *stream;

static int paCallBack( const void *inputBuffer, void *outputBuffer,
                            unsigned long framesPerBuffer,
                            const PaStreamCallbackTimeInfo* timeInfo,
                            PaStreamCallbackFlags statusFlags,
                            void *userData );

#endif

